Package weka.core.converters

# Class ConverterUtils

java.lang.Object
weka.core.converters.ConverterUtils

All Implemented Interfaces:
  `Serializable`, `RevisionHandler`

public class ConverterUtils extends Object implements Serializable, RevisionHandler
Utility routines for the converter package.

Version:
  $Revision: 6416 $
Author:
  Mark Hall (mhall@cs.waikato.ac.nz), FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - `Serializable`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`ConverterUtils.DataSink`
Helper class for saving data to files.
`static class`
`ConverterUtils.DataSource`
Helper class for loading data from files and URLs.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CORE_FILE_LOADERS`
the core loaders - hardcoded list necessary for RMI/Remote Experiments (comma-separated list).
`static final String`
`CORE_FILE_SAVERS`
the core savers - hardcoded list necessary for RMI/Remote Experiments (comma-separated list).

## Constructor Summary

Constructors
Constructor
Description
`ConverterUtils()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`errms(StreamTokenizer tokenizer, String theMsg)`
Throws error message with line number and last token read.
`static Vector<String>`
`getFileLoaders()`
returns a vector with the classnames of all the file loaders.
`static Vector<String>`
`getFileSavers()`
returns a vector with the classnames of all the file savers.
`static void`
`getFirstToken(StreamTokenizer tokenizer)`
Gets token, skipping empty lines.
`static AbstractFileLoader`
`getLoaderForExtension(String extension)`
tries to determine the loader to use for this kind of extension, returns null if none can be found.
`static AbstractFileLoader`
`getLoaderForFile(File file)`
tries to determine the loader to use for this kind of file, returns null if none can be found.
`static AbstractFileLoader`
`getLoaderForFile(String filename)`
tries to determine the loader to use for this kind of file, returns null if none can be found.
`String`
`getRevision()`
Returns the revision string.
`static AbstractFileSaver`
`getSaverForExtension(String extension)`
tries to determine the saver to use for this kind of extension, returns null if none can be found.
`static AbstractFileSaver`
`getSaverForFile(File file)`
tries to determine the saver to use for this kind of file, returns null if none can be found.
`static AbstractFileSaver`
`getSaverForFile(String filename)`
tries to determine the saver to use for this kind of file, returns null if none can be found.
`static void`
`getToken(StreamTokenizer tokenizer)`
Gets token.
`static Vector<String>`
`getURLFileLoaders()`
returns a vector with the classnames of all the URL file loaders.
`static AbstractFileLoader`
`getURLLoaderForExtension(String extension)`
tries to determine the URL loader to use for this kind of extension, returns null if none can be found.
`static AbstractFileLoader`
`getURLLoaderForFile(File file)`
tries to determine the URL loader to use for this kind of file, returns null if none can be found.
`static AbstractFileLoader`
`getURLLoaderForFile(String filename)`
tries to determine the URL loader to use for this kind of file, returns null if none can be found.
`static boolean`
`isCoreFileLoader(String classname)`
checks whether the given class is one of the hardcoded core file loaders.
`static boolean`
`isCoreFileSaver(String classname)`
checks whether the given class is one of the hardcoded core file savers.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CORE_FILE_LOADERS

public static final String CORE_FILE_LOADERS
the core loaders - hardcoded list necessary for RMI/Remote Experiments (comma-separated list).

### CORE_FILE_SAVERS

public static final String CORE_FILE_SAVERS
the core savers - hardcoded list necessary for RMI/Remote Experiments (comma-separated list).

## Constructor Details

### ConverterUtils

public ConverterUtils()

## Method Details

### getFirstToken

public static void getFirstToken(StreamTokenizer tokenizer) throws IOException
Gets token, skipping empty lines.

Parameters:
  `tokenizer` - the stream tokenizer
Throws:
  `IOException` - if reading the next token fails

### getToken

public static void getToken(StreamTokenizer tokenizer) throws IOException
Gets token.

Parameters:
  `tokenizer` - the stream tokenizer
Throws:
  `IOException` - if reading the next token fails

### errms

public static void errms(StreamTokenizer tokenizer, String theMsg) throws IOException
Throws error message with line number and last token read.

Parameters:
  `tokenizer` - the stream tokenizer
  `theMsg` - the error message to be thrown
Throws:
  `IOException` - containing the error message

### isCoreFileLoader

public static boolean isCoreFileLoader(String classname)
checks whether the given class is one of the hardcoded core file loaders.

Parameters:
  `classname` - the class to check
Returns:
  true if the class is one of the core loaders
See Also:
  - `CORE_FILE_LOADERS`

### getFileLoaders

public static Vector<String> getFileLoaders()
returns a vector with the classnames of all the file loaders.

Returns:
  the classnames of the loaders

### getLoaderForFile

public static AbstractFileLoader getLoaderForFile(String filename)
tries to determine the loader to use for this kind of file, returns null if none can be found.

Parameters:
  `filename` - the file to return a converter for
Returns:
  the converter if one was found, null otherwise

### getLoaderForFile

public static AbstractFileLoader getLoaderForFile(File file)
tries to determine the loader to use for this kind of file, returns null if none can be found.

Parameters:
  `file` - the file to return a converter for
Returns:
  the converter if one was found, null otherwise

### getLoaderForExtension

public static AbstractFileLoader getLoaderForExtension(String extension)
tries to determine the loader to use for this kind of extension, returns null if none can be found.

Parameters:
  `extension` - the file extension to return a converter for
Returns:
  the converter if one was found, null otherwise

### getURLFileLoaders

public static Vector<String> getURLFileLoaders()
returns a vector with the classnames of all the URL file loaders.

Returns:
  the classnames of the loaders

### getURLLoaderForFile

public static AbstractFileLoader getURLLoaderForFile(String filename)
tries to determine the URL loader to use for this kind of file, returns null if none can be found.

Parameters:
  `filename` - the file to return a URL converter for
Returns:
  the converter if one was found, null otherwise

### getURLLoaderForFile

public static AbstractFileLoader getURLLoaderForFile(File file)
tries to determine the URL loader to use for this kind of file, returns null if none can be found.

Parameters:
  `file` - the file to return a URL converter for
Returns:
  the converter if one was found, null otherwise

### getURLLoaderForExtension

public static AbstractFileLoader getURLLoaderForExtension(String extension)
tries to determine the URL loader to use for this kind of extension, returns null if none can be found.

Parameters:
  `extension` - the file extension to return a URL converter for
Returns:
  the converter if one was found, null otherwise

### isCoreFileSaver

public static boolean isCoreFileSaver(String classname)
checks whether the given class is one of the hardcoded core file savers.

Parameters:
  `classname` - the class to check
Returns:
  true if the class is one of the core savers
See Also:
  - `CORE_FILE_SAVERS`

### getFileSavers

public static Vector<String> getFileSavers()
returns a vector with the classnames of all the file savers.

Returns:
  the classnames of the savers

### getSaverForFile

public static AbstractFileSaver getSaverForFile(String filename)
tries to determine the saver to use for this kind of file, returns null if none can be found.

Parameters:
  `filename` - the file to return a converter for
Returns:
  the converter if one was found, null otherwise

### getSaverForFile

public static AbstractFileSaver getSaverForFile(File file)
tries to determine the saver to use for this kind of file, returns null if none can be found.

Parameters:
  `file` - the file to return a converter for
Returns:
  the converter if one was found, null otherwise

### getSaverForExtension

public static AbstractFileSaver getSaverForExtension(String extension)
tries to determine the saver to use for this kind of extension, returns null if none can be found.

Parameters:
  `extension` - the file extension to return a converter for
Returns:
  the converter if one was found, null otherwise

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Returns:
  the revision